VTK: vtkAbstractWidget Class Reference

| VTK 9.3.1

Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
vtkAbstractWidget Class Referenceabstract

define the API for widget / widget representation More...

`#include <vtkAbstractWidget.h>`

Inheritance diagram for vtkAbstractWidget:
[legend]
Collaboration diagram for vtkAbstractWidget:
[legend]

## Public Member Functions
void | SetEnabled (int) override
| Methods for activating this widget. More...
vtkWidgetEventTranslator * | GetEventTranslator ()
| Get the event translator. More...
virtual void | CreateDefaultRepresentation ()=0
| Create the default widget representation if one is not set. More...
void | Render ()
| This method is called by subclasses when a render method is to be invoked on the vtkRenderWindowInteractor. More...
void | SetParent (vtkAbstractWidget *parent)
| Specifying a parent to this widget is used when creating composite widgets. More...
virtual vtkAbstractWidget * | GetParent ()
void | SetPriority (float) override
| Override the superclass method. More...
virtual void | SetProcessEvents (vtkTypeBool)
| Methods to change whether the widget responds to interaction. More...
virtual vtkTypeBool | GetProcessEvents ()
| Methods to change whether the widget responds to interaction. More...
virtual void | ProcessEventsOn ()
| Methods to change whether the widget responds to interaction. More...
virtual void | ProcessEventsOff ()
| Methods to change whether the widget responds to interaction. More...
vtkWidgetRepresentation * | GetRepresentation ()
| Return an instance of vtkWidgetRepresentation used to represent this widget in the scene. More...
virtual void | SetManagesCursor (vtkTypeBool)
| Turn on or off the management of the cursor. More...
virtual vtkTypeBool | GetManagesCursor ()
| Turn on or off the management of the cursor. More...
virtual void | ManagesCursorOn ()
| Turn on or off the management of the cursor. More...
virtual void | ManagesCursorOff ()
| Turn on or off the management of the cursor. More...
Public Member Functions inherited from vtkInteractorObserver
vtkInteractorObserver * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
int | GetEnabled ()
void | EnabledOn ()
void | EnabledOff ()
void | On ()
void | Off ()
virtual void | OnChar ()
| Sets up the keypress-i event. More...
virtual void | SetInteractor (vtkRenderWindowInteractor *iren)
| This method is used to associate the widget with the render window interactor. More...
virtual vtkRenderWindowInteractor * | GetInteractor ()
| This method is used to associate the widget with the render window interactor. More...
virtual float | GetPriority ()
| Set/Get the priority at which events are processed. More...
virtual void | PickingManagedOn ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | PickingManagedOff ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | SetPickingManaged (bool managed)
| Enable/Disable the use of a manager to process the picking. More...
virtual bool | GetPickingManaged ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | SetKeyPressActivation (vtkTypeBool)
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual vtkTypeBool | GetKeyPressActivation ()
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual void | KeyPressActivationOn ()
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual void | KeyPressActivationOff ()
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual void | SetKeyPressActivationValue (char)
| Specify which key press value to use to activate the interactor observer (if key press activation is enabled). More...
virtual char | GetKeyPressActivationValue ()
| Specify which key press value to use to activate the interactor observer (if key press activation is enabled). More...
virtual vtkRenderer * | GetDefaultRenderer ()
| Set/Get the default renderer to use when activating the interactor observer. More...
virtual void | SetDefaultRenderer (vtkRenderer *)
| Set/Get the default renderer to use when activating the interactor observer. More...
virtual vtkRenderer * | GetCurrentRenderer ()
| Set/Get the current renderer. More...
virtual void | SetCurrentRenderer (vtkRenderer *)
| Set/Get the current renderer. More...
void | GrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods enable an interactor observer to exclusively grab all events invoked by its associated vtkRenderWindowInteractor. More...
void | ReleaseFocus ()
| These methods enable an interactor observer to exclusively grab all events invoked by its associated vtkRenderWindowInteractor. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Protected Member Functions
| vtkAbstractWidget ()
| ~vtkAbstractWidget () override
void | SetWidgetRepresentation (vtkWidgetRepresentation *r)
virtual void | SetCursor (int vtkNotUsed(state))
Protected Member Functions inherited from vtkInteractorObserver
| vtkInteractorObserver ()
| ~vtkInteractorObserver () override
virtual void | RegisterPickers ()
| Register internal Pickers in the Picking Manager. More...
void | UnRegisterPickers ()
| Unregister internal pickers from the Picking Manager. More...
vtkPickingManager * | GetPickingManager ()
| Return the picking manager associated on the context on which the observer currently belong. More...
vtkAssemblyPath * | GetAssemblyPath (double X, double Y, double Z, vtkAbstractPropPicker *picker)
| Proceed to a pick, whether through the PickingManager if the picking is managed or directly using the picker, and return the assembly path. More...
int | RequestCursorShape (int requestedShape)
virtual void | StartInteraction ()
| Utility routines used to start and end interaction. More...
virtual void | EndInteraction ()
| Utility routines used to start and end interaction. More...
void | ComputeDisplayToWorld (double x, double y, double z, double worldPt[4])
| Helper method for subclasses. More...
void | ComputeWorldToDisplay (double x, double y, double z, double displayPt[3])
| Helper method for subclasses. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Static Protected Member Functions
static void | ProcessEventsHandler (vtkObject *object, unsigned long event, void *clientdata, void *calldata)
Static Protected Member Functions inherited from vtkInteractorObserver
static void | ProcessEvents (vtkObject *object, unsigned long event, void *clientdata, void *calldata)
| Handles the char widget activation event. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Protected Attributes
vtkWidgetRepresentation * | WidgetRep
vtkTypeBool | ManagesCursor
vtkWidgetEventTranslator * | EventTranslator
vtkWidgetCallbackMapper * | CallbackMapper
vtkAbstractWidget * | Parent
void * | CallData
vtkTypeBool | ProcessEvents
int | LastDevice
Protected Attributes inherited from vtkInteractorObserver
int | Enabled
vtkCallbackCommand * | EventCallbackCommand
vtkCallbackCommand * | KeyPressCallbackCommand
float | Priority
bool | PickingManaged
vtkTypeBool | KeyPressActivation
char | KeyPressActivationValue
vtkRenderWindowInteractor * | Interactor
vtkRenderer * | CurrentRenderer
vtkRenderer * | DefaultRenderer
unsigned long | CharObserverTag
unsigned long | DeleteObserverTag
vtkObserverMediator * | ObserverMediator
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
typedef vtkInteractorObserver | Superclass
| Standard macros implementing standard VTK methods. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard macros implementing standard VTK methods. More...
static vtkAbstractWidget * | SafeDownCast (vtkObjectBase *o)
| Standard macros implementing standard VTK methods. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard macros implementing standard VTK methods. More...
vtkAbstractWidget * | NewInstance () const
| Standard macros implementing standard VTK methods. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard macros implementing standard VTK methods. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard macros implementing standard VTK methods. More...

## Additional Inherited Members
Public Types inherited from vtkInteractorObserver
typedef vtkObject | Superclass
Static Public Member Functions inherited from vtkInteractorObserver
static vtkTypeBool | IsTypeOf (const char *type)
static vtkInteractorObserver * | SafeDownCast (vtkObjectBase *o)
static void | ComputeDisplayToWorld (vtkRenderer *ren, double x, double y, double z, double worldPt[4])
| Convenience methods for outside classes. More...
static void | ComputeWorldToDisplay (vtkRenderer *ren, double x, double y, double z, double displayPt[3])
| Convenience methods for outside classes. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Detailed Description

define the API for widget / widget representation

The vtkAbstractWidget defines an API and implements methods common to all widgets using the interaction/representation design. In this design, the term interaction means that part of the widget that performs event handling, while the representation corresponds to a vtkProp (or the subclass vtkWidgetRepresentation) used to represent the widget. vtkAbstractWidget also implements some methods common to all subclasses.

Note that vtkAbstractWidget provides access to the vtkWidgetEventTranslator. This class is responsible for translating VTK events (defined in vtkCommand.h) into widget events (defined in vtkWidgetEvent.h). This class can be manipulated so that different VTK events can be mapped into widget events, thereby allowing the modification of event bindings. Each subclass of vtkAbstractWidget defines the events to which it responds.

Warning
  Note that the pair ( vtkAbstractWidget / vtkWidgetRepresentation ) is an implementation of the second generation VTK Widgets design. In the first generation design, widgets were implemented in a single monolithic class. This design was problematic because in client-server application it was difficult to manage widgets properly. Also, new "representations" or look-and-feel, for a widget required a whole new class, with a lot of redundant code. The separation of the widget event handling and representation enables users and developers to create new appearances for the widget. It also facilitates parallel processing, where the client application handles events, and remote representations of the widget are slaves to the client (and do not handle events).

See also
  vtkWidgetRepresentation vtkWidgetEventTranslator vtkWidgetCallbackMapper

Events:
  vtkCommand::DisableEvent vtkCommand::EnableEvent

Online Examples:

Definition at line 63 of file vtkAbstractWidget.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkInteractorObserver vtkAbstractWidget::Superclass

Standard macros implementing standard VTK methods.

Definition at line 70 of file vtkAbstractWidget.h.

## Constructor & Destructor Documentation

## ◆ vtkAbstractWidget()

vtkAbstractWidget::vtkAbstractWidget | ( |  | ) |
| protected

## ◆ ~vtkAbstractWidget()

vtkAbstractWidget::~vtkAbstractWidget | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkAbstractWidget::IsTypeOf | ( | const char * | type | ) |
| static

Standard macros implementing standard VTK methods.

## ◆ IsA()

virtual vtkTypeBool vtkAbstractWidget::IsA | ( | const char * | type | ) |
| virtual

Standard macros implementing standard VTK methods.

Reimplemented from vtkInteractorObserver.

Reimplemented in vtkVRPanelWidget, vtkVRMenuWidget, vtkTextWidget, vtkTensorWidget, vtkTensorProbeWidget, vtkSplineWidget2, vtkSphereWidget2, vtkSliderWidget, vtkSeedWidget, vtkScalarBarWidget, vtkResliceCursorWidget, vtkRectilinearWipeWidget, vtkProgressBarWidget, vtkPolyLineWidget, vtkPointCloudWidget, vtkPlaybackWidget, vtkParallelopipedWidget, vtkOrientationWidget, vtkMagnifierWidget, vtkLogoWidget, vtkLineWidget2, vtkLightWidget, vtkImplicitPlaneWidget2, vtkImplicitCylinderWidget, vtkHoverWidget, vtkHandleWidget, vtkFinitePlaneWidget, vtkDistanceWidget, vtkDisplaySizedImplicitPlaneWidget, vtkCoordinateFrameWidget, vtkContourWidget, vtkContinuousValueWidget, vtkCompassWidget, vtkCheckerboardWidget, vtkCenteredSliderWidget, vtkCaptionWidget, vtkCameraWidget, vtkCameraPathWidget, vtkCameraOrientationWidget, vtkCamera3DWidget, vtkButtonWidget, vtkBoxWidget2, vtkBorderWidget, vtkBiDimensionalWidget, vtkBalloonWidget, vtkAxesTransformWidget, vtkAngleWidget, vtkAffineWidget, vtk3DCursorWidget, and vtkQWidgetWidget.

## ◆ SafeDownCast()

static vtkAbstractWidget* vtkAbstractWidget::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard macros implementing standard VTK methods.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkAbstractWidget::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard macros implementing standard VTK methods.

Reimplemented from vtkInteractorObserver.

Reimplemented in vtkVRPanelWidget, vtkVRMenuWidget, vtkTextWidget, vtkTensorWidget, vtkTensorProbeWidget, vtkSplineWidget2, vtkSphereWidget2, vtkSliderWidget, vtkSeedWidget, vtkScalarBarWidget, vtkResliceCursorWidget, vtkRectilinearWipeWidget, vtkProgressBarWidget, vtkPolyLineWidget, vtkPointCloudWidget, vtkPlaybackWidget, vtkParallelopipedWidget, vtkOrientationWidget, vtkMagnifierWidget, vtkLogoWidget, vtkLineWidget2, vtkLightWidget, vtkImplicitPlaneWidget2, vtkImplicitCylinderWidget, vtkHoverWidget, vtkHandleWidget, vtkFinitePlaneWidget, vtkDistanceWidget, vtkDisplaySizedImplicitPlaneWidget, vtkCoordinateFrameWidget, vtkContourWidget, vtkContinuousValueWidget, vtkCompassWidget, vtkCheckerboardWidget, vtkCenteredSliderWidget, vtkCaptionWidget, vtkCameraWidget, vtkCameraPathWidget, vtkCameraOrientationWidget, vtkCamera3DWidget, vtkButtonWidget, vtkBoxWidget2, vtkBorderWidget, vtkBiDimensionalWidget, vtkBalloonWidget, vtkAxesTransformWidget, vtkAngleWidget, vtkAffineWidget, vtk3DCursorWidget, and vtkQWidgetWidget.

## ◆ NewInstance()

vtkAbstractWidget* vtkAbstractWidget::NewInstance | ( |  | ) | const

Standard macros implementing standard VTK methods.

## ◆ PrintSelf()

void vtkAbstractWidget::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard macros implementing standard VTK methods.

Reimplemented from vtkObject.

Reimplemented in vtkVRPanelWidget, vtkVRMenuWidget, vtkTextWidget, vtkTensorWidget, vtkTensorProbeWidget, vtkSplineWidget2, vtkSphereWidget2, vtkSliderWidget, vtkSeedWidget, vtkScalarBarWidget, vtkResliceCursorWidget, vtkRectilinearWipeWidget, vtkProgressBarWidget, vtkPolyLineWidget, vtkPointCloudWidget, vtkPlaybackWidget, vtkParallelopipedWidget, vtkMagnifierWidget, vtkLogoWidget, vtkLineWidget2, vtkLightWidget, vtkImplicitPlaneWidget2, vtkImplicitCylinderWidget, vtkHoverWidget, vtkHandleWidget, vtkFinitePlaneWidget, vtkDistanceWidget, vtkDisplaySizedImplicitPlaneWidget, vtkCoordinateFrameWidget, vtkContourWidget, vtkContinuousValueWidget, vtkCompassWidget, vtkCheckerboardWidget, vtkCenteredSliderWidget, vtkCaptionWidget, vtkCameraWidget, vtkCameraPathWidget, vtkCameraOrientationWidget, vtkButtonWidget, vtkBoxWidget2, vtkBorderWidget, vtkBiDimensionalWidget, vtkBalloonWidget, vtkAxesTransformWidget, vtkAngleWidget, and vtkAffineWidget.

## ◆ SetEnabled()

void vtkAbstractWidget::SetEnabled | ( | int |  | ) |
| overridevirtual

Methods for activating this widget.

Note that the widget representation must be specified or the widget will not appear. ProcessEvents (On by default) must be On for Enabled widget to respond to interaction. If ProcessEvents is Off, enabling/disabling a widget merely affects the visibility of the representation.

Reimplemented from vtkInteractorObserver.

Reimplemented in vtkSeedWidget, vtkResliceCursorWidget, vtkParallelopipedWidget, vtkHoverWidget, vtkDistanceWidget, vtkContourWidget, vtkCheckerboardWidget, vtkButtonWidget, vtkBiDimensionalWidget, vtkBalloonWidget, vtkAngleWidget, vtkAffineWidget, vtkTensorWidget, vtkSplineWidget2, vtkSphereWidget2, vtkPolyLineWidget, vtkPointCloudWidget, vtkMagnifierWidget, vtkLineWidget2, vtkImplicitPlaneWidget2, vtkHandleWidget, vtkDisplaySizedImplicitPlaneWidget, vtkCoordinateFrameWidget, vtkCaptionWidget, vtkCameraPathWidget, vtkCamera3DWidget, vtkBoxWidget2, and vtkAxesTransformWidget.

## ◆ SetProcessEvents()

virtual void vtkAbstractWidget::SetProcessEvents | ( | vtkTypeBool |  | ) |
| virtual

Methods to change whether the widget responds to interaction.

Set this to Off to disable interaction. On by default. Subclasses must override SetProcessEvents() to make sure that they pass on the flag to all component widgets.

Reimplemented in vtkSeedWidget, vtkParallelopipedWidget, vtkLineWidget2, vtkDistanceWidget, vtkBiDimensionalWidget, vtkAxesTransformWidget, and vtkAngleWidget.

## ◆ GetProcessEvents()

virtual vtkTypeBool vtkAbstractWidget::GetProcessEvents | ( |  | ) |
| inlinevirtual

Methods to change whether the widget responds to interaction.

Set this to Off to disable interaction. On by default. Subclasses must override SetProcessEvents() to make sure that they pass on the flag to all component widgets.

Reimplemented in vtkScalarBarWidget, and vtkBorderWidget.

Definition at line 91 of file vtkAbstractWidget.h.

## ◆ ProcessEventsOn()

virtual void vtkAbstractWidget::ProcessEventsOn | ( |  | ) |
| virtual

Methods to change whether the widget responds to interaction.

Set this to Off to disable interaction. On by default. Subclasses must override SetProcessEvents() to make sure that they pass on the flag to all component widgets.

## ◆ ProcessEventsOff()

virtual void vtkAbstractWidget::ProcessEventsOff | ( |  | ) |
| virtual

Methods to change whether the widget responds to interaction.

Set this to Off to disable interaction. On by default. Subclasses must override SetProcessEvents() to make sure that they pass on the flag to all component widgets.

## ◆ GetEventTranslator()

vtkWidgetEventTranslator* vtkAbstractWidget::GetEventTranslator | ( |  | ) |
| inline

Get the event translator.

Careful manipulation of this class enables the user to override the default event bindings.

Definition at line 104 of file vtkAbstractWidget.h.

## ◆ CreateDefaultRepresentation()

virtual void vtkAbstractWidget::CreateDefaultRepresentation | ( |  | ) |
| pure virtual

Create the default widget representation if one is not set.

The representation defines the geometry of the widget (i.e., how it appears) as well as providing special methods for manipulting the state and appearance of the widget.

Implemented in vtkVRPanelWidget, vtkVRMenuWidget, vtkTextWidget, vtkTensorWidget, vtkTensorProbeWidget, vtkSplineWidget2, vtkSphereWidget2, vtkSliderWidget, vtkSeedWidget, vtkScalarBarWidget, vtkResliceCursorWidget, vtkRectilinearWipeWidget, vtkProgressBarWidget, vtkPolyLineWidget, vtkPointCloudWidget, vtkPlaybackWidget, vtkParallelopipedWidget, vtkOrientationWidget, vtkMagnifierWidget, vtkLogoWidget, vtkLineWidget2, vtkLightWidget, vtkImplicitPlaneWidget2, vtkImplicitCylinderWidget, vtkHoverWidget, vtkHandleWidget, vtkFinitePlaneWidget, vtkDistanceWidget, vtkDisplaySizedImplicitPlaneWidget, vtkCoordinateFrameWidget, vtkContourWidget, vtkCompassWidget, vtkCheckerboardWidget, vtkCenteredSliderWidget, vtkCaptionWidget, vtkCameraWidget, vtkCameraPathWidget, vtkCameraOrientationWidget, vtkCamera3DWidget, vtkButtonWidget, vtkBoxWidget2, vtkBorderWidget, vtkBiDimensionalWidget, vtkBalloonWidget, vtkAxesTransformWidget, vtkAngleWidget, vtkAffineWidget, vtk3DCursorWidget, and vtkQWidgetWidget.

## ◆ Render()

void vtkAbstractWidget::Render | ( |  | ) |

This method is called by subclasses when a render method is to be invoked on the vtkRenderWindowInteractor.

This method should be called (instead of vtkRenderWindow::Render() because it has built into it optimizations for minimizing renders and/or speeding renders.

## ◆ SetParent()

void vtkAbstractWidget::SetParent | ( | vtkAbstractWidget * | parent | ) |
| inline

Specifying a parent to this widget is used when creating composite widgets.

It is an internal method not meant to be used by the public. When a widget has a parent, it defers the rendering to the parent. It may also defer managing the cursor (see ManagesCursor ivar).

Definition at line 128 of file vtkAbstractWidget.h.

## ◆ GetParent()

virtual vtkAbstractWidget* vtkAbstractWidget::GetParent | ( |  | ) |
| virtual

## ◆ GetRepresentation()

vtkWidgetRepresentation* vtkAbstractWidget::GetRepresentation | ( |  | ) |
| inline

Return an instance of vtkWidgetRepresentation used to represent this widget in the scene.

Note that the representation is a subclass of vtkProp (typically a subclass of vtkWidgetRepresentation) so it can be added to the renderer independent of the widget.

Definition at line 138 of file vtkAbstractWidget.h.

## ◆ SetManagesCursor()

virtual void vtkAbstractWidget::SetManagesCursor | ( | vtkTypeBool |  | ) |
| virtual

Turn on or off the management of the cursor.

Cursor management is typically disabled for subclasses when composite widgets are created. For example, vtkHandleWidgets are often used to create composite widgets, and the parent widget takes over the cursor management.

## ◆ GetManagesCursor()

virtual vtkTypeBool vtkAbstractWidget::GetManagesCursor | ( |  | ) |
| virtual

Turn on or off the management of the cursor.

Cursor management is typically disabled for subclasses when composite widgets are created. For example, vtkHandleWidgets are often used to create composite widgets, and the parent widget takes over the cursor management.

## ◆ ManagesCursorOn()

virtual void vtkAbstractWidget::ManagesCursorOn | ( |  | ) |
| virtual

Turn on or off the management of the cursor.

Cursor management is typically disabled for subclasses when composite widgets are created. For example, vtkHandleWidgets are often used to create composite widgets, and the parent widget takes over the cursor management.

## ◆ ManagesCursorOff()

virtual void vtkAbstractWidget::ManagesCursorOff | ( |  | ) |
| virtual

Turn on or off the management of the cursor.

Cursor management is typically disabled for subclasses when composite widgets are created. For example, vtkHandleWidgets are often used to create composite widgets, and the parent widget takes over the cursor management.

## ◆ SetPriority()

void vtkAbstractWidget::SetPriority | ( | float |  | ) |
| overridevirtual

Override the superclass method.

This will automatically change the priority of the widget. Unlike the superclass documentation, no methods such as SetInteractor to null and reset it etc. are necessary

Reimplemented from vtkInteractorObserver.

## ◆ ProcessEventsHandler()

static void vtkAbstractWidget::ProcessEventsHandler | ( | vtkObject * | object,
|  | unsigned long | event,
|  | void * | clientdata,
|  | void * | calldata
| ) |  |
| staticprotected

## ◆ SetWidgetRepresentation()

void vtkAbstractWidget::SetWidgetRepresentation | ( | vtkWidgetRepresentation * | r | ) |
| protected

## ◆ SetCursor()

virtual void vtkAbstractWidget::SetCursor | ( | int | vtkNotUsedstate | ) |
| inlineprotectedvirtual

Definition at line 182 of file vtkAbstractWidget.h.

## Member Data Documentation

## ◆ WidgetRep

vtkWidgetRepresentation* vtkAbstractWidget::WidgetRep
| protected

Definition at line 178 of file vtkAbstractWidget.h.

## ◆ ManagesCursor

vtkTypeBool vtkAbstractWidget::ManagesCursor
| protected

Definition at line 181 of file vtkAbstractWidget.h.

## ◆ EventTranslator

vtkWidgetEventTranslator* vtkAbstractWidget::EventTranslator
| protected

Definition at line 185 of file vtkAbstractWidget.h.

## ◆ CallbackMapper

vtkWidgetCallbackMapper* vtkAbstractWidget::CallbackMapper
| protected

Definition at line 186 of file vtkAbstractWidget.h.

## ◆ Parent

vtkAbstractWidget* vtkAbstractWidget::Parent
| protected

Definition at line 189 of file vtkAbstractWidget.h.

## ◆ CallData

void* vtkAbstractWidget::CallData
| protected

Definition at line 194 of file vtkAbstractWidget.h.

## ◆ ProcessEvents

vtkTypeBool vtkAbstractWidget::ProcessEvents
| protected

Definition at line 198 of file vtkAbstractWidget.h.

## ◆ LastDevice

int vtkAbstractWidget::LastDevice
| protected

Definition at line 203 of file vtkAbstractWidget.h.

The documentation for this class was generated from the following file:

- Interaction/Widgets/vtkAbstractWidget.h